package com.its.api.its.service.vms;

import com.its.api.its.model.dto.vms.TbVmsLumSetSchDto;
import com.its.api.its.model.entity.vms.TbVmsLumSetSch;
import com.its.api.its.model.entity.vms.TbVmsLumSetSchKey;
import com.its.api.its.repository.vms.TbVmsLumSetSchRepository;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbVmsLumSetSchService {

    private final TbVmsLumSetSchRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbVmsLumSetSch requireOne(TbVmsLumSetSchKey id) {
        return this.repo.findById(id)
                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbVmsLumSetSchDto> findAll() {
        List<TbVmsLumSetSchDto> result = new ArrayList<>();
        List<TbVmsLumSetSch> data = this.repo.findAll();
        for (TbVmsLumSetSch entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbVmsLumSetSchDto findById(TbVmsLumSetSchKey key) {
        Optional<TbVmsLumSetSch> data = this.repo.findByKey(key.getVmsCtlrNmbr(), key.getSchTime());
        return data.orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + key.getVmsCtlrNmbr())).toDto();

/*
        if (data.isPresent()) {
            return data.get().toDto();
        }
        throw new NoSuchElementException("데이터가 존재하지 않습니다: " + key.getVmsCtlrNmbr());
*/
/*
        TbVmsLumSetSch entity = requireOne(id);
        return entity.toDto();
*/
    }

    // 데이터 변경
    @Transactional
    public TbVmsLumSetSchDto updateById(TbVmsLumSetSchKey id, TbVmsLumSetSchDto.TbVmsLumSetSchUpdReq req) {
        TbVmsLumSetSch entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbVmsLumSetSchDto> mergeInfoList(List<TbVmsLumSetSchDto.TbVmsLumSetSchUpdReq> reqList) {
        List<TbVmsLumSetSchDto> result = new ArrayList<>();
        for (TbVmsLumSetSchDto.TbVmsLumSetSchUpdReq req : reqList) {
            TbVmsLumSetSch obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbVmsLumSetSchDto mergeInfo(TbVmsLumSetSchDto.TbVmsLumSetSchUpdReq req) {
        TbVmsLumSetSch obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbVmsLumSetSchDto deleteById(TbVmsLumSetSchKey id) {
        TbVmsLumSetSch entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbVmsLumSetSchDto> deleteByIds(List<TbVmsLumSetSchKey> ids) {
        List<TbVmsLumSetSchDto> result = new ArrayList<>();
        for (TbVmsLumSetSchKey id : ids) {
            Optional<TbVmsLumSetSch> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
